
# Installation Guide for the Multicoin Faucet
**This is working on Ubuntu 16.04, Altcoin Wallet installation _required_**

Before to start using this Guide you must have a full synced and running Wallet.

**_Install apache Webserver and php_**

`sudo apt-get install apache2`

`sudo apt-get install php`

`sudo apt-get install php-mysqli`

`sudo apt-get install libapache2-mod-php7.0`

`sudo a2enmod php7.0`

`rm /var/www/html/index.html`

`service apache2 restart`
___

**_Install SSL Certificates_**

If you want to add a SSL-certificate I recommend you using certbot: https://certbot.eff.org/

You should install the certificate before the Faucet installation. Just follow the installation guide on the website.



___

**_Install and configure MySQL_**

`sudo apt-get install mysql-server`

-> While installing you will be pormted to set a root passwort, use a strong password and write it down some where!

The first step to configure mysql for production mode is to run

`mysql_secure_installation`

Then, when asked, enter your root password. 

Further I would deny the first two questions (n) and accept the remaining questions (y)


___

**Install and configure the Faucet**


`cd /var/www/html`

`git clone https://github.com/WlanWerner/Multicoin-Faucet.git`

`cp -r Multicoin-Faucet/* /var/www/html/`

-> Now you have all the faucet Files in the Webserver root.

___

**Create Database with User**

`mysql -u root -p`

-> enter root password

You are now logged in as mysql User

`CREATE USER 'newuser'@'localhost' IDENTIFIED BY 'password';`

->Replace newuser and password between the quotes

`CREATE DATABASE faucet;`

`Grant All Privileges ON faucet.* TO 'newuser'@'localhost';`

-> Replace the newuser with the User you created in the step above

`USE faucet;`
`SOURCE /var/www/html/faucet.sql;`
-> to fill in the Database with all it's necessary rows

Quit MySQL with 

`\q`

___

**Last Steps**

`nano config.php`

Now you just have to fill in the config with all necessary informations. The values are explained behind the // signs.

___

**Optionally**

Create a img folder in the webserver-root and put a favicon.ico in the img folder

When using the basic template you should add a Coinname.png in the img folder. Note that the large and lower case of the Coinname.png should match with the Coinname set in the Faucet config.

If you set "stage_payments" => true and "staged_payment_cron_only" => true , you will need to create a cronjob for /cron/run.php and /lib/proxy_filter/cron/tor.php

If you set "stage_payments" => true and "staged_payment_cron_only" => false you just have to create a cronjob for /lib/proxy_filter/cron/tor.php

IMPORTANT: The tor proxy list gets downloaded from https://www.dan.me.uk/torlist/ - He only allows to download once a hour! Please note that you will be banned from the service if you exceed this quota! Create a .htaccess and .htpasswd for the cronjob folder and /lib/proxy_filter/cron/ to secure them.

	
